
function [XS,X,Y]=sonagram(sig,fe,attenuation,fen_temp,f_plot);
%
%  XW = sonagram(sig,fe, attenuation,fen_temp,f_plot);
%	Calcul du sonagramme du signal sig et impression de
%	l'image obtenue par le module en dB de XW.
%	XW : sonagramme complexe,
%	sig : variable contenant le signal,
%	fe : frequence d'chantillonnage du signal, par defaut 8000 Hz.
%  attenuation = -50 db par rapport au pic le plus haut par dfaut.
%  fen_temp en ms par dfaut 5ms pour fe = 8000Hz
%  f_plot frquence max d'affichage par dfaut fe/2
%
% Solange ROSSATO ICP 02/97

% frequence d'echantillonnage du signal par dfaut
if nargin == 1 
   fe=8000;
   attenuation = 50;
   L=40*fe/8000;
elseif nargin == 2
   attenuation = 50;
   L=40*fe/8000;
elseif nargin ==3
   L=40*fe/8000;   
elseif nargin>= 4
   L=fix(fen_temp*fe/1000/2)*2;
end
%tic

%
%if (length(sig)<2001*fe/8000)
N=256*fe/8000;		%nb de points de la fft
pas=20*fe/8000;		% pas de calcul 

% filtre passe-haut
B=[1 -0.95];
%B = [1 0]

Npts = floor((length(sig)-L/2)/pas);

XW=zeros(N,Npts);
k = 1;

for n=L/2:pas:length(sig)-L/2
   w=hamming(L);
	xw=filter(B,1,sig(n-L/2+1:n+L/2)).*w;
	fxw=fft(xw,N);
   size(fxw);
   XW(:,k)= fxw;
   k = k+1;
end;

if exist('f_plot')
   if f_plot>fe/2
      f_plot = fe/2;
   end
   Nmax = round(f_plot/fe*N);
else
   Nmax = N/2;
   f_plot = fe/2;
end

%seuil inferieur
%XW = max(XW,max(max(abs(XW)))/10000);	
XS=max(XW(N-Nmax:N,:),1e-3);
%axes de l'image
X = linspace(0,length(sig)/fe,Npts);
%X=( (length(sig)-L/2)/fe*1000 : -pas/fe*1000 : (L/2+1)/fe*1000 );
%axe des temps en ms
Y = linspace(f_plot,0,Nmax);
%Y=(1:N/2)*fe/N;			% axe des frequences
  
figure;
M = max(max(20*log10(abs(XS))));
imagesc(X,Y,20*log10(abs(XS)),[M-attenuation M])
colormap((1-gray))
   axis('xy');
xlabel('Temps (s)');
ylabel('Frequence (Hz)');

%toc