function [ind_front] = detecte_front(fich_wav)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  Nom : detecte_front												
%%  Permet de dtecter le 1er front montant sur les 2 bips de synchro
%%
%%  entres
%%    fich_wav : fichier wav a traiter (mono ou stereo)
%%
%%  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%														
%%  date : 12 fvrier 2007
%%  auteur : Christophe Savariaux								
%%  ICP - Grenoble		
%%														
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% On lit le debut du fichier Wav
wav_temp=wavread(fich_wav,900000);
%wav_temp=wavread(fich_wav,[26000000 26250000]);

% on teste si le fichiet est un mono ou stereo
if size(wav_temp,2) == 2 
    wav = wav_temp(:,2); % c'est un fichier stereo et seule la voie de droite nous interesse
else
    wav = wav_temp;
end

% on prend la drive du signal
sig = diff(wav);

% on effectue un seuillage
seuil = 0.3*max(sig);
sig1 = abs(sig) > seuil;

% Utilisation de la derive pour detecter les fronts montants et descendants
nb_mon=0; % nbre de front

for i=2:length(sig1)
   if (sig1(i-1)== 0 & sig1(i) == 1)
      nb_mon=nb_mon+1;
      ind_deb(nb_mon) = i;
   end
end

if ~isempty(ind_deb)
    % le premier front est bon
    ind_front = ind_deb(1);

    % on cherche le front du 2eme bip
    for i=2:length(ind_deb)-1
        if ind_deb(i)-ind_deb(i-1) > 100 %on n'est pas  l'interieur d'un bip (2 fronts proches)
            ind_front = [ind_front ind_deb(i)];
        end
    end
else
    disp('Pas de bip dtect dans le fichier Wav !')
end

        

