function detrame

% fonction permettant de dtramer des images se trouvant dans un mme rpertoire
% sans utiliser de paramtres en entre
%
%
% la trame A est antrieure dans le temps  la trame B
% l'image commence toujours par une ligne impaire -> trame B
% si le nombre de lignes de l'image  dtramer est pair, la dernire ligne est une ligne de la trame A
% si le nombre de lignes de l'image  dtramer est impair, la dernire ligne est une ligne de la trame B
%
% Dernieres Modifs :
%   CS le 21/03/06
%       Remplace l'ancien detrame.m avec paramtres d'entre
%   CS le 15/02/08
%       Modification de la gestion des numeros d'images de maniere
%       automatique

close all;
t0 = clock;

% Si images issues du logiciel DPS
flag_DPS = 1;
if flag_DPS
    disp('Attention on traite des images issues de DPS ! Ordre des trames invers !')
end

% On va pointer sur l'image de dpart
[filename_deb, chemin, filterindex] = uigetfile('*_*.bmp',...
    'Recherche de la premiere image');
if filterindex == 0
    return;
end

% On rcupre le numro de la premire image
%num = str2num(char(regexp(filename_deb, '[0-9][0-9][0-9][0-9][0-9]','match')))
num_deb=[];
car=char(regexp(filename_deb, '\d','match'));
car=car';
nb_digit=size(car,2);
for ii=1:nb_digit
    num_deb=[num_deb , car(1,ii)];
end
num = str2num(num_deb);

% On rcupre la racine des images
prefixe_image = filename_deb(1:regexp(filename_deb, '[\d]')-1);

% On va pointer sur l'image de fin
[filename_fin, pathname, filterindex] = uigetfile('*_*.bmp',...
    'Recherche de la dernire image');
if filterindex == 0
    return;
end

% On rcupre le numro de la dernire image
%fin = str2num(char(regexp(filename_fin, '[0-9][0-9][0-9][0-9][0-9]','match')));
num_fin=[];
car=char(regexp(filename_fin, '\d','match'));
car=car';
nb_digit=size(car,2);
for ii=1:nb_digit
    num_fin=[num_fin , car(1,ii)];
end
fin = str2num(num_fin);


% On demande s'il y a un recadrage  effectuer
beep;
if strcmp(input('Voulez-vous faire un recadrage des images ? (O/N) ','s'),'O')
    disp('On va recadrer les images ! ')
    flag_recadrage = 1;
    x_pixel_deb = str2num(input('abscisse en pixel du bord gauche (1<x1<720) : ','s'));
    if (x_pixel_deb < 0) ||  (x_pixel_deb > 720)
        disp('Vous devez rentrer un chiffre entre 0 et 720 !!')
        return;
    end
    x_pixel_fin = str2num(input('abscisse en pixel du bord droit (x1<x2<720) : ','s'));
    if (x_pixel_deb > x_pixel_fin) ||  (x_pixel_fin > 720)
        msg = ['Vous devez rentrer un chiffre entre ' num2str(x_pixel_deb) ' et 720 !!'];
        disp(msg)
        return;
    end
    y_pixel_deb = str2num(input('ordonne en pixel du bord haut (1<y1<576) : ','s'));
    if (y_pixel_deb < 0) ||  (y_pixel_deb > 576)
        disp('Vous devez rentrer un chiffre entre 0 et 576 !!')
        return;
    end
    y_pixel_fin = str2num(input('ordonne en pixel du bord bas (y1<y2<576) : ','s'));
    if (y_pixel_deb > y_pixel_fin) ||  (x_pixel_fin > 576)
        msg = ['Vous devez rentrer un chiffre entre ' num2str(y_pixel_deb) ' et 576 !!'];
        disp(msg)
        return;
    end
else
    disp('Pas de recadrage... ')
end

while (num ~= fin+1) %on traite toutes les images du rpertoire
	img_A = []; % matrice pour la trame A
    img_B = []; % matrice pour la trame B
    img_A_moy = []; % matrice pour la trame A
    img_B_moy = []; % matrice pour la trame B
    % on definit le chemin d'entre et le nb de zero en sortie
    add_zero = [];
    if length(num2str(fin)) < 5
        for ii=1:nb_digit-length(num2str(fin))
            add_zero = [add_zero num2str(zeros(1,1))];
        end
        path = [chemin prefixe_image add_zero int2str(num)];
    else
        path = [chemin prefixe_image int2str(num)];
    end

    info = [path ' en cours de traitement ...'];
    disp(info);
     
	[img,map] = imread(path,'bmp'); 
	[li,co,rgb] = size(img);
    
	for i=1:li % on parcourt l'image d'origine et on prend une ligne sur deux
        % Attention pour image issue de DPS : trame A et B inverses
   	    if rem(i,2) == 0 % image paire en premier = trame A
   		    %img_A = [img_A ; img(i,353:718,:)];
            img_A = [img_A ; img(i,:,:)];
   	    else
      	    %img_B = [img_B ; img(i,353:718,:)];
            img_B = [img_B ; img(i,:,:)];
   	    end
    end
    
    % moyennage des trames A et B
    [la,ca,rgba] = size(img_A);
    [lb,cb,rgbb] = size(img_B);
    img_A_moy = [img_A_moy ; img_A(1,:,:)]; % on rajoute toujours en plus la premire ligne pour les trames A (duplique)
 
    if la == lb % si on a le meme nb de ligne sur trame A et B on ne fait qu'une seule boucle
      for i=1:la-1 % on parcourt l'image dtrame et on moyenne les lignes manquantes
   	    ligne1a = double(img_A(i,:,:));
        ligne2a = double(img_A(i+1,:,:));
        ligne_moya = fix((ligne1a + ligne2a)/2);
        img_A_moy = [img_A_moy ; ligne1a ; ligne_moya];
   	    ligne1b = double(img_B(i,:,:));
        ligne2b = double(img_B(i+1,:,:));
        ligne_moyb = fix((ligne1b + ligne2b)/2);
        img_B_moy = [img_B_moy ; ligne1b ; ligne_moyb];
      end
      %  la fin on rajoute la dernire
      img_A_moy = [img_A_moy ; img_A(la,:,:)]; 
      img_B_moy = [img_B_moy ; img_B(lb,:,:)];
    else % on separe les 2 trames
      % moyennage de la trame A  
      for i=1:la-1 % on parcourt l'image dtrame et on moyenne les lignes manquantes
   	    ligne1 = double(img_A(i,:,:));
        ligne2 = double(img_A(i+1,:,:));
        ligne_moy = fix((ligne1 + ligne2)/2);
        img_A_moy = [img_A_moy ; ligne1 ; ligne_moy];
      end
      img_A_moy = [img_A_moy ; img_A(la,:,:)]; %  la fin on rajoute la dernire
    
      % moyennage de la trame B
      for i=1:lb-1 % on parcourt l'image dtrame et on moyenne les lignes manquantes
   	    ligne1 = double(img_B(i,:,:));
        ligne2 = double(img_B(i+1,:,:));
        ligne_moy = fix((ligne1 + ligne2)/2);
        img_B_moy = [img_B_moy ; ligne1 ; ligne_moy];
      end
      img_B_moy = [img_B_moy ; img_B(lb,:,:)]; %  la fin on rajoute la dernire
    end

    if rem(li,2) == 0 % on regarde combien de lignes a l'image pour le moyennage des trames (voir si il faut rajouter une ligne)
        % pour la trame B, on rajoute la dernire ligne
        img_B_moy = [img_B_moy ; img_B(lb,:,:)];
    else
        % pour la trame A, on rajoute la dernire ligne
        img_A_moy = [img_A_moy ; img_A(la,:,:)];
    end
    
    % On definit le nom du fichier de sortie
    if length(num2str(fin)) < 5
        if flag_DPS  % On inverse les trames A et B
            imA = [chemin prefixe_image add_zero int2str(num) '_B.bmp']; % path de la trame A  enregistrer
            imB = [chemin prefixe_image add_zero int2str(num) '_A.bmp']; % path de la trame B  enregistrer
        else
            imA = [chemin prefixe_image add_zero int2str(num) '_A.bmp']; % path de la trame A  enregistrer
            imB = [chemin prefixe_image add_zero int2str(num) '_B.bmp']; % path de la trame B  enregistrer
        end
    else
        if flag_DPS % On inverse les trames A et B
            imA = [chemin prefixe_image int2str(num) '_B.bmp']; % path de la trame A  enregistrer
            imB = [chemin prefixe_image int2str(num) '_A.bmp']; % path de la trame B  enregistrer
        else
            imA = [chemin prefixe_image int2str(num) '_A.bmp']; % path de la trame A  enregistrer
            imB = [chemin prefixe_image int2str(num) '_B.bmp']; % path de la trame B  enregistrer
        end
    end


    % On teste si on a demand un recadrage
    if exist('flag_recadrage')
        % On decoupe une partie de l'image en X
        imwrite(img_A_moy(y_pixel_deb:y_pixel_fin,x_pixel_deb:x_pixel_fin,:), imA, 'bmp');
        imwrite(img_B_moy(y_pixel_deb:y_pixel_fin,x_pixel_deb:x_pixel_fin,:), imB, 'bmp');
    else
        imwrite(img_A_moy, imA, 'bmp');
        imwrite(img_B_moy, imB, 'bmp');
    end
    
    num = num + 1;
   
end %fin du while
msg= ['Temps de calcul : ' num2str(etime(clock,t0))];
disp(msg)