% function do_TCoffset(fic,offset,sign)
%
% convertit un fichier batch de grab d'images
% utile pour generer automatiquement le fichier batch
% pour la deuxieme camera, dont le Time Code est decale
%
% fic : fichier batch originel 
% offset : offset a appliquer sur les TCs de fic.
%    Il doit etre fourni en nombre d'images
%   off = Dimg+Ds*25+Dmn*60*25+Dhour*60*60*25 ;
% sign : '+' ou '-' en fonction de si on veut additionner ou soustraire
%
% exemple : do_TCoffset('batch_pb140300_vcv.txt',1500,'+')
%
% REM : le fichier [fic '_offset'] est genere.
% Attention ! Il reste ensuite a changer le nom des fichiers
% de recuperation d'images dans le batch resultat !
%
% Modifi le 24/01/05 par CS : rajout du parametre sign pour avoir le choix
% de soustraire ou additionner un offset

function do_TCoffset(fic,off,sign)

fid1 = fopen(fic,'r');
fid2 = fopen([fic(1:(size(fic,2)-4)) '_offset.txt'],'w');
if (fid1 == -1)
   errordlg('Erreur d''ouverture du fichier de report !!!!','Erreur','on');
   return;
end

if (fid2 == -1)
    errordlg('Erreur de creation du fichier de report_offset !!','Erreur','on');
    return;
end

line=fgets(fid1);
while line ~= -1            % pour chaque ligne
	if (line(1,1)~='#') % si commentaire on passe
        if ~(size(line,2) == 2)       % ou ligne vide, 
		[D,X1,X2,indice]=sscanf(line,'%d:%d:%d:%d',[4,2]);
		temp=[];
		for i=1:2              % les deux TC (arret et fin)
			date=D(:,i);
			h=date(1); mn=date(2); s=date(3); img=date(4);
            if sign == '+'
                tim = img+s*25+mn*60*25+h*60*60*25 + off ;
            elseif sign == '-'
                tim = img+s*25+mn*60*25+h*60*60*25 - off ;
            end
            
			ht=fix(tim/(25*60*60));
			mnt=fix((tim-(ht*25*60*60))/(60*25));       
			st=fix((tim-(ht*25*60*60+mnt*25*60))/25);
			imgt=tim-ht*(60*60*25)-mnt*(60*25)-st*25;
			temp=[temp sprintf('%.2d:%.2d:%.2d:%.2d ',ht,mnt,st,imgt)];
		end
		[taille]=size(line,2);
		line=[temp line(indice:taille)];  % on ecrase les valeurs precedentes
        end
    end
	fprintf(fid2,'%s',line);             % on ecrit la ligne
	line=fgets(fid1);                    % ligne suivante
end
fclose(fid1);
fclose(fid2);

return ;
