function [sig_out] = filtre_stopband_CS(sig,fech,fcc)

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Fichier : filtre_stopband_CS.m
% Auteur : CS
% Date : 28/01/08
% Contenu : Filtrage stop bande de Butter du 3e ordre
%           fcc = [fcc1 fcc2]
%           fcc1 : frequence de coupure basse
%           fcc2 : frequence de coupure haute
% exemple : pour supprimer du 50 Hz
%   [sig_out] = filtre_stopband_CS(sig,22050,[40 60]);
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%===============================
% TEST SUR LE NOMBRE D'ARGUMENTS
%===============================

if nargin < 3
   chaine_erreur = sprintf(' Nombre d''arguments insuffisants !\n Syntaxe : filtre_phaut_CS(sig,fech,fcc)');
   errordlg(chaine_erreur, 'Erreur', 'on');
   return;
end


% On definit un filtre de Butterworth du 3eme ordre
[b,a] = butter(3,fcc*2/fech,'stop');
sig_out = filtfilt(b,a,sig);

% si on veut plotter la fft 
flag_fft = 1;
hold on
if flag_fft
    long_sig = length(sig);
    sig_fft = fft(sig(1:long_sig));
    f = linspace(0,fech,long_sig+1);
    f = f(1:end-1);
    plot(f,abs(sig_fft));
    sig_out_fft = fft(sig_out(1:long_sig));
    hold on
    plot(f,abs(sig_out_fft),'g');
end
