function stereo2mono(rep)

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%	Nom : stereo2mono													
%	Permet de tranformer les fichiers stereo 16bits (.wav)
%   en fichiers mono 16 bits (.wav) ou on ne garde que la voie de gauche !!
%
%   Input
%     rep : repertoire d'entre + type de fichiers
%
%   Exemple : stereo2mono('d:\users\*.wav')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%														
%	date : 5 mars 2005
%	auteur : Christophe Savariaux								
% 	ICP - Grenoble		
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[liste, long, nb_item] = ls2list(rep);

for i=1:nb_item
    fich_out = [];
    wav_stereo = 0;
    wav_L = 0;
    wav_new = 0;
    [wav_stereo,Fe] = wavread(liste(i,:));
    
    % on genere le nouveau nom
    fich_out = [liste(i,1:long(i)-4) '_mn.wav'];

    % On recupere la voie de gauche
    wav_L = wav_stereo(:,1); % le signal utile
    wavwrite(wav_L,Fe,fich_out);
end

